install.sh 36.3 KB
Newer Older
H
hzcheng 已提交
1 2
#!/bin/bash
#
L
lihui 已提交
3
# This file is used to install database on linux systems. The operating system
H
hzcheng 已提交
4 5 6 7 8
# is required to use systemd to manage services at boot

set -e
#set -x

L
lihui 已提交
9 10
verMode=edge
pagMode=full
S
slguan 已提交
11

H
Hui Li 已提交
12 13 14
iplist=""
serverFqdn=""

H
hzcheng 已提交
15
# -----------------------Variables definition---------------------
F
Frozen 已提交
16
script_dir=$(dirname $(readlink -f "$0"))
H
hzcheng 已提交
17 18 19 20 21 22 23 24 25 26 27
# Dynamic directory
data_dir="/var/lib/taos"
log_dir="/var/log/taos"

data_link_dir="/usr/local/taos/data"
log_link_dir="/usr/local/taos/log"

cfg_install_dir="/etc/taos"

bin_link_dir="/usr/bin"
lib_link_dir="/usr/lib"
H
Hui Li 已提交
28
lib64_link_dir="/usr/lib64"
H
hzcheng 已提交
29 30 31 32 33 34 35 36
inc_link_dir="/usr/include"

#install main path
install_main_dir="/usr/local/taos"

# old bin dir
bin_dir="/usr/local/taos/bin"

S
slguan 已提交
37
# v1.5 jar dir
H
Hui Li 已提交
38
#v15_java_app_dir="/usr/local/lib/taos"
S
slguan 已提交
39

H
hzcheng 已提交
40
service_config_dir="/etc/systemd/system"
S
slguan 已提交
41 42
nginx_port=6060
nginx_dir="/usr/local/nginxd"
H
hzcheng 已提交
43 44 45 46 47 48 49 50

# Color setting
RED='\033[0;31m'
GREEN='\033[1;32m'
GREEN_DARK='\033[0;32m'
GREEN_UNDERLINE='\033[4;32m'
NC='\033[0m'

P
plum-lihui 已提交
51 52 53 54
csudo=""
if command -v sudo > /dev/null; then
    csudo="sudo"
fi
H
hzcheng 已提交
55

S
slguan 已提交
56 57
update_flag=0

L
lihui 已提交
58
initd_mod=0
P
plum-lihui 已提交
59 60 61
service_mod=2
if pidof systemd &> /dev/null; then
    service_mod=0
62
elif $(which service &> /dev/null); then
P
plum-lihui 已提交
63
    service_mod=1
64
    service_config_dir="/etc/init.d"
L
lihui 已提交
65
    if $(which chkconfig &> /dev/null); then
66
         initd_mod=1
L
lihui 已提交
67 68 69 70 71 72 73
    elif $(which insserv &> /dev/null); then
        initd_mod=2
    elif $(which update-rc.d &> /dev/null); then
        initd_mod=3
    else
        service_mod=2
    fi
74
else
P
plum-lihui 已提交
75
    service_mod=2
H
hzcheng 已提交
76 77
fi

L
lihui 已提交
78 79 80 81

# get the operating system type for using the corresponding init file
# ubuntu/debian(deb), centos/fedora(rpm), others: opensuse, redhat, ..., no verification
#osinfo=$(awk -F= '/^NAME/{print $2}' /etc/os-release)
H
Hui Li 已提交
82
if [[ -e /etc/os-release ]]; then
H
Hui Li 已提交
83 84 85 86
  osinfo=$(cat /etc/os-release | grep "NAME" | cut -d '"' -f2)   ||:
else
  osinfo=""
fi
L
lihui 已提交
87 88 89
#echo "osinfo: ${osinfo}"
os_type=0
if echo $osinfo | grep -qwi "ubuntu" ; then
H
Hui Li 已提交
90
#  echo "This is ubuntu system"
L
lihui 已提交
91 92
  os_type=1
elif echo $osinfo | grep -qwi "debian" ; then
H
Hui Li 已提交
93
#  echo "This is debian system"
L
lihui 已提交
94 95
  os_type=1
elif echo $osinfo | grep -qwi "Kylin" ; then
H
Hui Li 已提交
96
#  echo "This is Kylin system"
L
lihui 已提交
97 98
  os_type=1
elif  echo $osinfo | grep -qwi "centos" ; then
H
Hui Li 已提交
99
#  echo "This is centos system"
L
lihui 已提交
100 101
  os_type=2
elif echo $osinfo | grep -qwi "fedora" ; then
H
Hui Li 已提交
102
#  echo "This is fedora system"
L
lihui 已提交
103 104
  os_type=2
else
H
Hui Li 已提交
105
  echo " osinfo: ${osinfo}"
106
  echo " This is an officially unverified linux system,"
H
Hui Li 已提交
107 108
  echo " if there are any problems with the installation and operation, "
  echo " please feel free to contact taosdata.com for support."
L
lihui 已提交
109
  os_type=1
L
lihui 已提交
110 111
fi

H
Hui Li 已提交
112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140

# =============================  get input parameters =================================================

# install.sh -v [server | client]  -e [yes | no] -i [systemd | service | ...]

# set parameters by default value
interactiveFqdn=yes   # [yes | no]
verType=server        # [server | client]
initType=systemd      # [systemd | service | ...]

while getopts "hv:e:i:" arg
do
  case $arg in
    e)
      #echo "interactiveFqdn=$OPTARG"
      interactiveFqdn=$( echo $OPTARG )
      ;;
    v)
      #echo "verType=$OPTARG"
      verType=$(echo $OPTARG)
      ;;
    i)
      #echo "initType=$OPTARG"
      initType=$(echo $OPTARG)
      ;;
    h)
      echo "Usage: `basename $0` -v [server | client]  -e [yes | no]"
      exit 0
      ;;
141
    ?) #unknow option
H
Hui Li 已提交
142 143 144 145 146 147
      echo "unkonw argument"
      exit 1
      ;;
  esac
done

H
Hui Li 已提交
148
#echo "verType=${verType} interactiveFqdn=${interactiveFqdn}"
H
Hui Li 已提交
149

150 151
function kill_process() {
  pid=$(ps -ef | grep "$1" | grep -v "grep" | awk '{print $2}')
L
lihui 已提交
152 153 154
  if [ -n "$pid" ]; then
    ${csudo} kill -9 $pid   || :
  fi
P
plum-lihui 已提交
155 156
}

H
hzcheng 已提交
157 158
function install_main_path() {
    #create install main dir and all sub dir
P
plum-lihui 已提交
159
    ${csudo} rm -rf ${install_main_dir}    || :
160
    ${csudo} mkdir -p ${install_main_dir}
P
plum-lihui 已提交
161
    ${csudo} mkdir -p ${install_main_dir}/cfg
162
    ${csudo} mkdir -p ${install_main_dir}/bin
P
plum-lihui 已提交
163 164 165 166 167
    ${csudo} mkdir -p ${install_main_dir}/connector
    ${csudo} mkdir -p ${install_main_dir}/driver
    ${csudo} mkdir -p ${install_main_dir}/examples
    ${csudo} mkdir -p ${install_main_dir}/include
    ${csudo} mkdir -p ${install_main_dir}/init.d
S
slguan 已提交
168 169 170
    if [ "$verMode" == "cluster" ]; then
        ${csudo} mkdir -p ${nginx_dir}
    fi
171

172
    if [[ -e ${script_dir}/email ]]; then
173 174
      ${csudo} cp ${script_dir}/email ${install_main_dir}/ ||:
    fi
H
hzcheng 已提交
175 176 177 178
}

function install_bin() {
    # Remove links
P
plum-lihui 已提交
179 180
    ${csudo} rm -f ${bin_link_dir}/taos     || :
    ${csudo} rm -f ${bin_link_dir}/taosd    || :
S
slguan 已提交
181
    ${csudo} rm -f ${bin_link_dir}/taosdemo || :
182
    ${csudo} rm -f ${bin_link_dir}/taosdump || :
P
plum-lihui 已提交
183
    ${csudo} rm -f ${bin_link_dir}/rmtaos   || :
H
Hui Li 已提交
184
    ${csudo} rm -f ${bin_link_dir}/tarbitrator   || :
H
Hui Li 已提交
185
    ${csudo} rm -f ${bin_link_dir}/set_core   || :
H
hzcheng 已提交
186

P
plum-lihui 已提交
187
    ${csudo} cp -r ${script_dir}/bin/* ${install_main_dir}/bin && ${csudo} chmod 0555 ${install_main_dir}/bin/*
H
hzcheng 已提交
188 189

    #Make link
H
Hui Li 已提交
190 191 192
    [ -x ${install_main_dir}/bin/taos ] && ${csudo} ln -s ${install_main_dir}/bin/taos ${bin_link_dir}/taos                      || :
    [ -x ${install_main_dir}/bin/taosd ] && ${csudo} ln -s ${install_main_dir}/bin/taosd ${bin_link_dir}/taosd                   || :
    [ -x ${install_main_dir}/bin/taosdemo ] && ${csudo} ln -s ${install_main_dir}/bin/taosdemo ${bin_link_dir}/taosdemo          || :
193
    [ -x ${install_main_dir}/bin/taosdump ] && ${csudo} ln -s ${install_main_dir}/bin/taosdump ${bin_link_dir}/taosdump          || :
H
Hui Li 已提交
194
    [ -x ${install_main_dir}/bin/remove.sh ] && ${csudo} ln -s ${install_main_dir}/bin/remove.sh ${bin_link_dir}/rmtaos          || :
H
Hui Li 已提交
195
    [ -x ${install_main_dir}/bin/set_core.sh ] && ${csudo} ln -s ${install_main_dir}/bin/set_core.sh ${bin_link_dir}/set_core    || :
H
Hui Li 已提交
196
    [ -x ${install_main_dir}/bin/tarbitrator ] && ${csudo} ln -s ${install_main_dir}/bin/tarbitrator ${bin_link_dir}/tarbitrator || :
S
slguan 已提交
197 198 199 200 201 202

    if [ "$verMode" == "cluster" ]; then
        ${csudo} cp -r ${script_dir}/nginxd/* ${nginx_dir} && ${csudo} chmod 0555 ${nginx_dir}/*
        ${csudo} mkdir -p ${nginx_dir}/logs
        ${csudo} chmod 777 ${nginx_dir}/sbin/nginx
    fi
H
hzcheng 已提交
203 204 205 206
}

function install_lib() {
    # Remove links
L
lihui 已提交
207
    ${csudo} rm -f ${lib_link_dir}/libtaos.*         || :
H
Hui Li 已提交
208
    ${csudo} rm -f ${lib64_link_dir}/libtaos.*       || :
H
Hui Li 已提交
209
    #${csudo} rm -rf ${v15_java_app_dir}              || :
210 211
    ${csudo} cp -rf ${script_dir}/driver/* ${install_main_dir}/driver && ${csudo} chmod 777 ${install_main_dir}/driver/*

P
plum-lihui 已提交
212 213
    ${csudo} ln -s ${install_main_dir}/driver/libtaos.* ${lib_link_dir}/libtaos.so.1
    ${csudo} ln -s ${lib_link_dir}/libtaos.so.1 ${lib_link_dir}/libtaos.so
214

H
Hui Li 已提交
215
    if [[ -d ${lib64_link_dir} && ! -e ${lib64_link_dir}/libtaos.so ]]; then
H
Hui Li 已提交
216 217 218
      ${csudo} ln -s ${install_main_dir}/driver/libtaos.* ${lib64_link_dir}/libtaos.so.1       || :
      ${csudo} ln -s ${lib64_link_dir}/libtaos.so.1 ${lib64_link_dir}/libtaos.so               || :
    fi
219 220

    #if [ "$verMode" == "cluster" ]; then
H
Hui Li 已提交
221 222 223 224 225
    #    # Compatible with version 1.5
    #    ${csudo} mkdir -p ${v15_java_app_dir}
    #    ${csudo} ln -s ${install_main_dir}/connector/taos-jdbcdriver-1.0.2-dist.jar ${v15_java_app_dir}/JDBCDriver-1.0.2-dist.jar
    #    ${csudo} chmod 777 ${v15_java_app_dir} || :
    #fi
226

H
Hui Li 已提交
227
    ${csudo} ldconfig
H
hzcheng 已提交
228 229
}

230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275
function install_jemalloc() {
    jemalloc_dir=${script_dir}/jemalloc

    if [ -d ${jemalloc_dir} ]; then
        ${csudo} /usr/bin/install -c -d /usr/local/bin

        if [ -f ${jemalloc_dir}/bin/jemalloc-config ]; then
            ${csudo} /usr/bin/install -c -m 755 ${jemalloc_dir}/bin/jemalloc-config /usr/local/bin
        fi
        if [ -f ${jemalloc_dir}/bin/jemalloc.sh ]; then
            ${csudo} /usr/bin/install -c -m 755 ${jemalloc_dir}/bin/jemalloc.sh /usr/local/bin
        fi
        if [ -f ${jemalloc_dir}/bin/jeprof ]; then
            ${csudo} /usr/bin/install -c -m 755 ${jemalloc_dir}/bin/jeprof /usr/local/bin
        fi
        if [ -f ${jemalloc_dir}/include/jemalloc/jemalloc.h ]; then
            ${csudo} /usr/bin/install -c -d /usr/local/include/jemalloc
            ${csudo} /usr/bin/install -c -m 644 ${jemalloc_dir}/include/jemalloc/jemalloc.h /usr/local/include/jemalloc
        fi
        if [ -f ${jemalloc_dir}/lib/libjemalloc.so.2 ]; then
            ${csudo} /usr/bin/install -c -d /usr/local/lib
            ${csudo} /usr/bin/install -c -m 755 ${jemalloc_dir}/lib/libjemalloc.so.2 /usr/local/lib
            ${csudo} ln -sf libjemalloc.so.2 /usr/local/lib/libjemalloc.so
            ${csudo} /usr/bin/install -c -d /usr/local/lib
            if [ -f ${jemalloc_dir}/lib/libjemalloc.a ]; then
                ${csudo} /usr/bin/install -c -m 755 ${jemalloc_dir}/lib/libjemalloc.a /usr/local/lib
            fi
            if [ -f ${jemalloc_dir}/lib/libjemalloc_pic.a ]; then
                ${csudo} /usr/bin/install -c -m 755 ${jemalloc_dir}/lib/libjemalloc_pic.a /usr/local/lib
            fi
            if [ -f ${jemalloc_dir}/lib/libjemalloc_pic.a ]; then
                ${csudo} /usr/bin/install -c -d /usr/local/lib/pkgconfig
                ${csudo} /usr/bin/install -c -m 644 ${jemalloc_dir}/lib/pkgconfig/jemalloc.pc /usr/local/lib/pkgconfig
            fi
        fi
        if [ -f ${jemalloc_dir}/share/doc/jemalloc/jemalloc.html ]; then
            ${csudo} /usr/bin/install -c -d /usr/local/share/doc/jemalloc
            ${csudo} /usr/bin/install -c -m 644 ${jemalloc_dir}/share/doc/jemalloc/jemalloc.html /usr/local/share/doc/jemalloc
        fi
        if [ -f ${jemalloc_dir}/share/man/man3/jemalloc.3 ]; then
            ${csudo} /usr/bin/install -c -d /usr/local/share/man/man3
            ${csudo} /usr/bin/install -c -m 644 ${jemalloc_dir}/share/man/man3/jemalloc.3 /usr/local/share/man/man3
        fi
    fi
}

H
hzcheng 已提交
276
function install_header() {
L
lihui 已提交
277
    ${csudo} rm -f ${inc_link_dir}/taos.h ${inc_link_dir}/taoserror.h    || :
278
    ${csudo} cp -f ${script_dir}/inc/* ${install_main_dir}/include && ${csudo} chmod 644 ${install_main_dir}/include/*
P
plum-lihui 已提交
279
    ${csudo} ln -s ${install_main_dir}/include/taos.h ${inc_link_dir}/taos.h
L
lihui 已提交
280
    ${csudo} ln -s ${install_main_dir}/include/taoserror.h ${inc_link_dir}/taoserror.h
H
hzcheng 已提交
281 282
}

H
Hui Li 已提交
283 284 285 286 287 288 289 290 291 292 293 294
function add_newHostname_to_hosts() {
  localIp="127.0.0.1"
  OLD_IFS="$IFS"
  IFS=" "
  iphost=$(cat /etc/hosts | grep $1 | awk '{print $1}')
  arr=($iphost)
  IFS="$OLD_IFS"
  for s in ${arr[@]}
  do
    if [[ "$s" == "$localIp" ]]; then
      return
    fi
295
  done
H
Hui Li 已提交
296 297 298 299 300
  ${csudo} echo "127.0.0.1  $1" >> /etc/hosts   ||:
}

function set_hostname() {
  echo -e -n "${GREEN}Please enter one hostname(must not be 'localhost')${NC}:"
301
    read newHostname
H
Hui Li 已提交
302 303 304 305 306 307 308 309 310 311 312 313 314
  while true; do
    if [[ ! -z "$newHostname" && "$newHostname" != "localhost" ]]; then
      break
    else
      read -p "Please enter one hostname(must not be 'localhost'):" newHostname
    fi
  done

  ${csudo} hostname $newHostname ||:
  retval=`echo $?`
  if [[ $retval != 0 ]]; then
   echo
   echo "set hostname fail!"
315
   return
H
Hui Li 已提交
316 317 318 319
  fi
  #echo -e -n "$(hostnamectl status --static)"
  #echo -e -n "$(hostnamectl status --transient)"
  #echo -e -n "$(hostnamectl status --pretty)"
320

H
Hui Li 已提交
321 322 323 324
  #ubuntu/centos /etc/hostname
  if [[ -e /etc/hostname ]]; then
    ${csudo} echo $newHostname > /etc/hostname   ||:
  fi
325

H
Hui Li 已提交
326 327 328 329 330 331
  #debian: #HOSTNAME=yourname
  if [[ -e /etc/sysconfig/network ]]; then
    ${csudo} sed -i -r "s/#*\s*(HOSTNAME=\s*).*/\1$newHostname/" /etc/sysconfig/network   ||:
  fi

  ${csudo} sed -i -r "s/#*\s*(fqdn\s*).*/\1$newHostname/" ${cfg_install_dir}/taos.cfg
332 333
  serverFqdn=$newHostname

H
Hui Li 已提交
334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350
  if [[ -e /etc/hosts ]]; then
    add_newHostname_to_hosts $newHostname
  fi
}

function is_correct_ipaddr() {
  newIp=$1
  OLD_IFS="$IFS"
  IFS=" "
  arr=($iplist)
  IFS="$OLD_IFS"
  for s in ${arr[@]}
  do
   if [[ "$s" == "$newIp" ]]; then
     return 0
   fi
  done
351

H
Hui Li 已提交
352 353 354 355 356 357 358 359 360 361 362 363 364
  return 1
}

function set_ipAsFqdn() {
  iplist=$(ip address |grep inet |grep -v inet6 |grep -v 127.0.0.1 |awk '{print $2}' |awk -F "/" '{print $1}') ||:
  if [ -z "$iplist" ]; then
    iplist=$(ifconfig |grep inet |grep -v inet6 |grep -v 127.0.0.1 |awk '{print $2}' |awk -F ":" '{print $2}') ||:
  fi

  if [ -z "$iplist" ]; then
    echo
    echo -e -n "${GREEN}Unable to get local ip, use 127.0.0.1${NC}"
    localFqdn="127.0.0.1"
365 366
    # Write the local FQDN to configuration file
    ${csudo} sed -i -r "s/#*\s*(fqdn\s*).*/\1$localFqdn/" ${cfg_install_dir}/taos.cfg
H
Hui Li 已提交
367 368 369
    serverFqdn=$localFqdn
    echo
    return
370 371
  fi

H
Hui Li 已提交
372 373 374 375 376 377 378 379
  echo -e -n "${GREEN}Please choose an IP from local IP list${NC}:"
  echo
  echo -e -n "${GREEN}$iplist${NC}"
  echo
  echo
  echo -e -n "${GREEN}Notes: if IP is used as the node name, data can NOT be migrated to other machine directly${NC}:"
  read localFqdn
    while true; do
380
      if [ ! -z "$localFqdn" ]; then
H
Hui Li 已提交
381 382 383 384 385 386
        # Check if correct ip address
        is_correct_ipaddr $localFqdn
        retval=`echo $?`
        if [[ $retval != 0 ]]; then
          read -p "Please choose an IP from local IP list:" localFqdn
        else
387 388
          # Write the local FQDN to configuration file
          ${csudo} sed -i -r "s/#*\s*(fqdn\s*).*/\1$localFqdn/" ${cfg_install_dir}/taos.cfg
H
Hui Li 已提交
389 390 391 392 393 394 395 396 397 398
          serverFqdn=$localFqdn
          break
        fi
      else
        read -p "Please choose an IP from local IP list:" localFqdn
      fi
    done
}

function local_fqdn_check() {
H
[NONE]  
Hui Li 已提交
399
  #serverFqdn=$(hostname)
H
Hui Li 已提交
400 401 402
  echo
  echo -e -n "System hostname is: ${GREEN}$serverFqdn${NC}"
  echo
403
  if [[ "$serverFqdn" == "" ]] || [[ "$serverFqdn" == "localhost"  ]]; then
H
Hui Li 已提交
404 405
    echo -e -n "${GREEN}It is strongly recommended to configure a hostname for this machine ${NC}"
    echo
406

H
Hui Li 已提交
407 408
    while true
    do
409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429
        read -r -p "Set hostname now? [Y/n] " input
        if [ ! -n "$input" ]; then
            set_hostname
            break
        else
            case $input in
                [yY][eE][sS]|[yY])
                    set_hostname
                    break
                    ;;

                [nN][oO]|[nN])
                    set_ipAsFqdn
                    break
                    ;;

                *)
                    echo "Invalid input..."
                    ;;
            esac
        fi
H
Hui Li 已提交
430 431 432 433
    done
  fi
}

H
hzcheng 已提交
434
function install_config() {
P
plum-lihui 已提交
435
    #${csudo} rm -f ${install_main_dir}/cfg/taos.cfg     || :
436

L
lihui 已提交
437
    if [ ! -f ${cfg_install_dir}/taos.cfg ]; then
P
plum-lihui 已提交
438 439 440
        ${csudo} mkdir -p ${cfg_install_dir}
        [ -f ${script_dir}/cfg/taos.cfg ] && ${csudo} cp ${script_dir}/cfg/taos.cfg ${cfg_install_dir}
        ${csudo} chmod 644 ${cfg_install_dir}/*
441 442
    fi

P
plum-lihui 已提交
443
    ${csudo} cp -f ${script_dir}/cfg/taos.cfg ${install_main_dir}/cfg/taos.cfg.org
L
lihui 已提交
444
    ${csudo} ln -s ${cfg_install_dir}/taos.cfg ${install_main_dir}/cfg
S
slguan 已提交
445

H
Hui Li 已提交
446
    [ ! -z $1 ] && return 0 || : # only install client
447

H
Hui Li 已提交
448 449 450
    if ((${update_flag}==1)); then
        return 0
    fi
451

H
Hui Li 已提交
452 453
    if [ "$interactiveFqdn" == "no" ]; then
        return 0
454 455
    fi

H
Hui Li 已提交
456
    local_fqdn_check
S
slguan 已提交
457

H
Hui Li 已提交
458 459 460 461 462 463 464
    #FQDN_FORMAT="(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)"
    #FQDN_FORMAT="(:[1-6][0-9][0-9][0-9][0-9]$)"
    #PORT_FORMAT="(/[1-6][0-9][0-9][0-9][0-9]?/)"
    #FQDN_PATTERN=":[0-9]{1,5}$"

    # first full-qualified domain name (FQDN) for TDengine cluster system
    echo
H
Hui Li 已提交
465
    echo -e -n "${GREEN}Enter FQDN:port (like h1.taosdata.com:6030) of an existing TDengine cluster node to join${NC}"
H
Hui Li 已提交
466
    echo
H
Hui Li 已提交
467
    echo -e -n "${GREEN}OR leave it blank to build one${NC}:"
H
Hui Li 已提交
468
    read firstEp
H
Hui Li 已提交
469 470 471 472
    while true; do
        if [ ! -z "$firstEp" ]; then
            # check the format of the firstEp
            #if [[ $firstEp == $FQDN_PATTERN ]]; then
473 474
                # Write the first FQDN to configuration file
                ${csudo} sed -i -r "s/#*\s*(firstEp\s*).*/\1$firstEp/" ${cfg_install_dir}/taos.cfg
S
slguan 已提交
475
                break
H
Hui Li 已提交
476 477 478 479 480 481
            #else
            #    read -p "Please enter the correct FQDN:port: " firstEp
            #fi
        else
            break
        fi
482
    done
H
Hui Li 已提交
483

484
    # user email
H
Hui Li 已提交
485 486 487 488 489 490 491 492 493 494
    #EMAIL_PATTERN='^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$'
    #EMAIL_PATTERN='^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$'
    #EMAIL_PATTERN="^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$"
    echo
    echo -e -n "${GREEN}Enter your email address for priority support or enter empty to skip${NC}: "
    read emailAddr
    while true; do
        if [ ! -z "$emailAddr" ]; then
            # check the format of the emailAddr
            #if [[ "$emailAddr" =~ $EMAIL_PATTERN ]]; then
495 496
                # Write the email address to temp file
                email_file="${install_main_dir}/email"
H
Hui Li 已提交
497
                ${csudo} bash -c "echo $emailAddr > ${email_file}"
498
                break
H
Hui Li 已提交
499
            #else
500
            #    read -p "Please enter the correct email address: " emailAddr
H
Hui Li 已提交
501 502 503 504
            #fi
        else
            break
        fi
505
    done
H
hzcheng 已提交
506 507
}

L
lihui 已提交
508

H
hzcheng 已提交
509
function install_log() {
P
plum-lihui 已提交
510 511
    ${csudo} rm -rf ${log_dir}  || :
    ${csudo} mkdir -p ${log_dir} && ${csudo} chmod 777 ${log_dir}
512

P
plum-lihui 已提交
513
    ${csudo} ln -s ${log_dir} ${install_main_dir}/log
H
hzcheng 已提交
514 515 516
}

function install_data() {
P
plum-lihui 已提交
517
    ${csudo} mkdir -p ${data_dir}
518 519

    ${csudo} ln -s ${data_dir} ${install_main_dir}/data
H
hzcheng 已提交
520 521 522
}

function install_connector() {
523
    ${csudo} cp -rf ${script_dir}/connector/ ${install_main_dir}/
H
hzcheng 已提交
524 525 526
}

function install_examples() {
S
slguan 已提交
527 528 529
    if [ -d ${script_dir}/examples ]; then
        ${csudo} cp -rf ${script_dir}/examples/* ${install_main_dir}/examples
    fi
H
hzcheng 已提交
530 531 532
}

function clean_service_on_sysvinit() {
L
lihui 已提交
533
    #restart_config_str="taos:2345:respawn:${service_config_dir}/taosd start"
534 535
    #${csudo} sed -i "\|${restart_config_str}|d" /etc/inittab || :

H
hzcheng 已提交
536
    if pidof taosd &> /dev/null; then
P
plum-lihui 已提交
537
        ${csudo} service taosd stop || :
H
hzcheng 已提交
538
    fi
539

H
Hui Li 已提交
540 541 542
    if pidof tarbitrator &> /dev/null; then
        ${csudo} service tarbitratord stop || :
    fi
L
lihui 已提交
543 544

    if ((${initd_mod}==1)); then
545
      if [ -e ${service_config_dir}/taosd ]; then
L
lihui 已提交
546
        ${csudo} chkconfig --del taosd || :
H
Hui Li 已提交
547 548
      fi

549
      if [ -e ${service_config_dir}/tarbitratord ]; then
H
Hui Li 已提交
550
        ${csudo} chkconfig --del tarbitratord || :
H
Hui Li 已提交
551
      fi
L
lihui 已提交
552
    elif ((${initd_mod}==2)); then
553
      if [ -e ${service_config_dir}/taosd ]; then
L
lihui 已提交
554
        ${csudo} insserv -r taosd || :
H
Hui Li 已提交
555 556
      fi
      if [ -e ${service_config_dir}/tarbitratord ]; then
H
Hui Li 已提交
557
        ${csudo} insserv -r tarbitratord || :
H
Hui Li 已提交
558
      fi
L
lihui 已提交
559
    elif ((${initd_mod}==3)); then
H
Hui Li 已提交
560
      if [ -e ${service_config_dir}/taosd ]; then
L
lihui 已提交
561
        ${csudo} update-rc.d -f taosd remove || :
H
Hui Li 已提交
562 563
      fi
      if [ -e ${service_config_dir}/tarbitratord ]; then
H
Hui Li 已提交
564
        ${csudo} update-rc.d -f tarbitratord remove || :
H
Hui Li 已提交
565
      fi
L
lihui 已提交
566
    fi
567

P
plum-lihui 已提交
568
    ${csudo} rm -f ${service_config_dir}/taosd || :
H
Hui Li 已提交
569
    ${csudo} rm -f ${service_config_dir}/tarbitratord || :
570

L
lihui 已提交
571 572 573
    if $(which init &> /dev/null); then
        ${csudo} init q || :
    fi
H
hzcheng 已提交
574 575 576 577 578 579 580
}

function install_service_on_sysvinit() {
    clean_service_on_sysvinit
    sleep 1

    # Install taosd service
L
lihui 已提交
581 582 583 584

    if ((${os_type}==1)); then
        ${csudo} cp -f ${script_dir}/init.d/taosd.deb ${install_main_dir}/init.d/taosd
        ${csudo} cp    ${script_dir}/init.d/taosd.deb ${service_config_dir}/taosd && ${csudo} chmod a+x ${service_config_dir}/taosd
H
Hui Li 已提交
585 586
        ${csudo} cp -f ${script_dir}/init.d/tarbitratord.deb ${install_main_dir}/init.d/tarbitratord
        ${csudo} cp    ${script_dir}/init.d/tarbitratord.deb ${service_config_dir}/tarbitratord && ${csudo} chmod a+x ${service_config_dir}/tarbitratord
L
lihui 已提交
587 588 589
    elif ((${os_type}==2)); then
        ${csudo} cp -f ${script_dir}/init.d/taosd.rpm ${install_main_dir}/init.d/taosd
        ${csudo} cp    ${script_dir}/init.d/taosd.rpm ${service_config_dir}/taosd && ${csudo} chmod a+x ${service_config_dir}/taosd
H
Hui Li 已提交
590 591
        ${csudo} cp -f ${script_dir}/init.d/tarbitratord.rpm ${install_main_dir}/init.d/tarbitratord
        ${csudo} cp    ${script_dir}/init.d/tarbitratord.rpm ${service_config_dir}/tarbitratord && ${csudo} chmod a+x ${service_config_dir}/tarbitratord
L
lihui 已提交
592
    fi
593

L
lihui 已提交
594 595
    #restart_config_str="taos:2345:respawn:${service_config_dir}/taosd start"
    #${csudo} grep -q -F "$restart_config_str" /etc/inittab || ${csudo} bash -c "echo '${restart_config_str}' >> /etc/inittab"
596

L
lihui 已提交
597 598 599
    if ((${initd_mod}==1)); then
        ${csudo} chkconfig --add taosd || :
        ${csudo} chkconfig --level 2345 taosd on || :
H
Hui Li 已提交
600 601
        ${csudo} chkconfig --add tarbitratord || :
        ${csudo} chkconfig --level 2345 tarbitratord on || :
L
lihui 已提交
602 603 604
    elif ((${initd_mod}==2)); then
        ${csudo} insserv taosd || :
        ${csudo} insserv -d taosd || :
H
Hui Li 已提交
605 606
        ${csudo} insserv tarbitratord || :
        ${csudo} insserv -d tarbitratord || :
L
lihui 已提交
607 608
    elif ((${initd_mod}==3)); then
        ${csudo} update-rc.d taosd defaults || :
H
Hui Li 已提交
609
        ${csudo} update-rc.d tarbitratord defaults || :
L
lihui 已提交
610
    fi
H
hzcheng 已提交
611 612 613 614 615 616
}

function clean_service_on_systemd() {
    taosd_service_config="${service_config_dir}/taosd.service"
    if systemctl is-active --quiet taosd; then
        echo "TDengine is running, stopping it..."
P
plum-lihui 已提交
617
        ${csudo} systemctl stop taosd &> /dev/null || echo &> /dev/null
H
hzcheng 已提交
618
    fi
P
plum-lihui 已提交
619 620
    ${csudo} systemctl disable taosd &> /dev/null || echo &> /dev/null
    ${csudo} rm -f ${taosd_service_config}
621

H
Hui Li 已提交
622 623 624 625 626 627 628
    tarbitratord_service_config="${service_config_dir}/tarbitratord.service"
    if systemctl is-active --quiet tarbitratord; then
        echo "tarbitrator is running, stopping it..."
        ${csudo} systemctl stop tarbitratord &> /dev/null || echo &> /dev/null
    fi
    ${csudo} systemctl disable tarbitratord &> /dev/null || echo &> /dev/null
    ${csudo} rm -f ${tarbitratord_service_config}
629

S
slguan 已提交
630 631 632 633 634 635 636
    if [ "$verMode" == "cluster" ]; then
        nginx_service_config="${service_config_dir}/nginxd.service"
        if systemctl is-active --quiet nginxd; then
            echo "Nginx for TDengine is running, stopping it..."
            ${csudo} systemctl stop nginxd &> /dev/null || echo &> /dev/null
        fi
        ${csudo} systemctl disable nginxd &> /dev/null || echo &> /dev/null
637 638
        ${csudo} rm -f ${nginx_service_config}
    fi
S
slguan 已提交
639
}
H
hzcheng 已提交
640 641 642 643 644 645 646

# taos:2345:respawn:/etc/init.d/taosd start

function install_service_on_systemd() {
    clean_service_on_systemd

    taosd_service_config="${service_config_dir}/taosd.service"
P
plum-lihui 已提交
647 648 649 650 651 652 653 654
    ${csudo} bash -c "echo '[Unit]'                             >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'Description=TDengine server service' >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'After=network-online.target'        >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'Wants=network-online.target'        >> ${taosd_service_config}"
    ${csudo} bash -c "echo                                      >> ${taosd_service_config}"
    ${csudo} bash -c "echo '[Service]'                          >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'Type=simple'                        >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'ExecStart=/usr/bin/taosd'           >> ${taosd_service_config}"
655
    ${csudo} bash -c "echo 'ExecStartPre=/usr/local/taos/bin/startPre.sh'         >> ${taosd_service_config}"
656
    ${csudo} bash -c "echo 'TimeoutStopSec=1000000s'            >> ${taosd_service_config}"
P
plum-lihui 已提交
657 658 659 660 661 662 663 664
    ${csudo} bash -c "echo 'LimitNOFILE=infinity'               >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'LimitNPROC=infinity'                >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'LimitCORE=infinity'                 >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'TimeoutStartSec=0'                  >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'StandardOutput=null'                >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'Restart=always'                     >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'StartLimitBurst=3'                  >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'StartLimitInterval=60s'             >> ${taosd_service_config}"
H
Hui Li 已提交
665
    #${csudo} bash -c "echo 'StartLimitIntervalSec=60s'          >> ${taosd_service_config}"
P
plum-lihui 已提交
666 667 668 669
    ${csudo} bash -c "echo                                      >> ${taosd_service_config}"
    ${csudo} bash -c "echo '[Install]'                          >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'WantedBy=multi-user.target'         >> ${taosd_service_config}"
    ${csudo} systemctl enable taosd
670

H
Hui Li 已提交
671 672 673 674 675 676 677 678 679
    tarbitratord_service_config="${service_config_dir}/tarbitratord.service"
    ${csudo} bash -c "echo '[Unit]'                                  >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'Description=TDengine arbitrator service' >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'After=network-online.target'             >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'Wants=network-online.target'             >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo                                           >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo '[Service]'                               >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'Type=simple'                             >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'ExecStart=/usr/bin/tarbitrator'          >> ${tarbitratord_service_config}"
680
    ${csudo} bash -c "echo 'TimeoutStopSec=1000000s'                 >> ${tarbitratord_service_config}"
H
Hui Li 已提交
681 682 683 684 685 686 687 688 689 690 691
    ${csudo} bash -c "echo 'LimitNOFILE=infinity'                    >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'LimitNPROC=infinity'                     >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'LimitCORE=infinity'                      >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'TimeoutStartSec=0'                       >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'StandardOutput=null'                     >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'Restart=always'                          >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'StartLimitBurst=3'                       >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'StartLimitInterval=60s'                  >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo                                           >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo '[Install]'                               >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'WantedBy=multi-user.target'              >> ${tarbitratord_service_config}"
692 693 694
    #${csudo} systemctl enable tarbitratord

    if [ "$verMode" == "cluster" ]; then
S
slguan 已提交
695
        nginx_service_config="${service_config_dir}/nginxd.service"
H
Hui Li 已提交
696 697 698 699 700 701 702 703 704 705
        ${csudo} bash -c "echo '[Unit]'                                             >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'Description=Nginx For TDengine Service'             >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'After=network-online.target'                        >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'Wants=network-online.target'                        >> ${nginx_service_config}"
        ${csudo} bash -c "echo                                                      >> ${nginx_service_config}"
        ${csudo} bash -c "echo '[Service]'                                          >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'Type=forking'                                       >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'PIDFile=/usr/local/nginxd/logs/nginx.pid'           >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'ExecStart=/usr/local/nginxd/sbin/nginx'             >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'ExecStop=/usr/local/nginxd/sbin/nginx -s stop'      >> ${nginx_service_config}"
706
        ${csudo} bash -c "echo 'TimeoutStopSec=1000000s'                            >> ${nginx_service_config}"
H
Hui Li 已提交
707 708 709 710 711 712 713 714 715 716 717
        ${csudo} bash -c "echo 'LimitNOFILE=infinity'                               >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'LimitNPROC=infinity'                                >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'LimitCORE=infinity'                                 >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'TimeoutStartSec=0'                                  >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'StandardOutput=null'                                >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'Restart=always'                                     >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'StartLimitBurst=3'                                  >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'StartLimitInterval=60s'                             >> ${nginx_service_config}"
        ${csudo} bash -c "echo                                                      >> ${nginx_service_config}"
        ${csudo} bash -c "echo '[Install]'                                          >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'WantedBy=multi-user.target'                         >> ${nginx_service_config}"
S
slguan 已提交
718 719 720 721 722
        if ! ${csudo} systemctl enable nginxd &> /dev/null; then
            ${csudo} systemctl daemon-reexec
            ${csudo} systemctl enable nginxd
        fi
        ${csudo} systemctl start nginxd
723
    fi
H
hzcheng 已提交
724 725 726
}

function install_service() {
P
plum-lihui 已提交
727
    if ((${service_mod}==0)); then
H
hzcheng 已提交
728
        install_service_on_systemd
P
plum-lihui 已提交
729
    elif ((${service_mod}==1)); then
H
hzcheng 已提交
730
        install_service_on_sysvinit
P
plum-lihui 已提交
731
    else
L
lihui 已提交
732
        # must manual stop taosd
733
        kill_process taosd
H
hzcheng 已提交
734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767
    fi
}

vercomp () {
    if [[ $1 == $2 ]]; then
        return 0
    fi
    local IFS=.
    local i ver1=($1) ver2=($2)
    # fill empty fields in ver1 with zeros
    for ((i=${#ver1[@]}; i<${#ver2[@]}; i++)); do
        ver1[i]=0
    done

    for ((i=0; i<${#ver1[@]}; i++)); do
        if [[ -z ${ver2[i]} ]]
        then
            # fill empty fields in ver2 with zeros
            ver2[i]=0
        fi
        if ((10#${ver1[i]} > 10#${ver2[i]}))
        then
            return 1
        fi
        if ((10#${ver1[i]} < 10#${ver2[i]}))
        then
            return 2
        fi
    done
    return 0
}

function is_version_compatible() {

L
lihui 已提交
768
    curr_version=$(${bin_dir}/taosd -V | head -1 | cut -d ' ' -f 3)
H
hzcheng 已提交
769

L
lihui 已提交
770
    min_compatible_version=$(${script_dir}/bin/taosd -V | head -1 | cut -d ' ' -f 5)
H
hzcheng 已提交
771 772 773 774 775 776 777 778 779 780 781 782 783 784 785

    vercomp $curr_version $min_compatible_version
    case $? in
        0) return 0;;
        1) return 0;;
        2) return 1;;
    esac
}

function update_TDengine() {
    # Start to update
    if [ ! -e taos.tar.gz ]; then
        echo "File taos.tar.gz does not exist"
        exit 1
    fi
L
lihui 已提交
786
    tar -zxf taos.tar.gz
H
hzcheng 已提交
787 788 789 790 791 792 793

    # Check if version compatible
    if ! is_version_compatible; then
        echo -e "${RED}Version incompatible${NC}"
        return 1
    fi

L
lihui 已提交
794
    echo -e "${GREEN}Start to update TDengine...${NC}"
H
hzcheng 已提交
795 796
    # Stop the service if running
    if pidof taosd &> /dev/null; then
P
plum-lihui 已提交
797 798 799 800
        if ((${service_mod}==0)); then
            ${csudo} systemctl stop taosd || :
        elif ((${service_mod}==1)); then
            ${csudo} service taosd stop || :
H
hzcheng 已提交
801
        else
802 803 804 805
            kill_process taosd
        fi
        sleep 1
    fi
806

807 808 809 810 811 812 813 814
    if [ "$verMode" == "cluster" ]; then
      if pidof nginx &> /dev/null; then
        if ((${service_mod}==0)); then
            ${csudo} systemctl stop nginxd || :
        elif ((${service_mod}==1)); then
            ${csudo} service nginxd stop || :
        else
            kill_process nginx
H
hzcheng 已提交
815 816
        fi
        sleep 1
817
      fi
H
hzcheng 已提交
818
    fi
819

H
hzcheng 已提交
820 821 822 823 824
    install_main_path

    install_log
    install_header
    install_lib
825
    install_jemalloc
L
lihui 已提交
826 827 828
    if [ "$pagMode" != "lite" ]; then
      install_connector
    fi
H
hzcheng 已提交
829 830 831 832
    install_examples
    if [ -z $1 ]; then
        install_bin
        install_service
833 834
        install_config

H
Hui Li 已提交
835
        openresty_work=false
836
        if [ "$verMode" == "cluster" ]; then
S
slguan 已提交
837 838 839 840 841 842 843 844 845 846
            # Check if openresty is installed
            # Check if nginx is installed successfully
            if type curl &> /dev/null; then
                if curl -sSf http://127.0.0.1:${nginx_port} &> /dev/null; then
                    echo -e "\033[44;32;1mNginx for TDengine is updated successfully!${NC}"
                    openresty_work=true
                else
                    echo -e "\033[44;31;5mNginx for TDengine does not work! Please try again!\033[0m"
                fi
            fi
847
        fi
H
hzcheng 已提交
848

H
Hui Li 已提交
849 850
        #echo
        #echo -e "\033[44;32;1mTDengine is updated successfully!${NC}"
H
hzcheng 已提交
851 852
        echo
        echo -e "${GREEN_DARK}To configure TDengine ${NC}: edit /etc/taos/taos.cfg"
P
plum-lihui 已提交
853 854 855
        if ((${service_mod}==0)); then
            echo -e "${GREEN_DARK}To start TDengine     ${NC}: ${csudo} systemctl start taosd${NC}"
        elif ((${service_mod}==1)); then
L
lihui 已提交
856
            echo -e "${GREEN_DARK}To start TDengine     ${NC}: ${csudo} service taosd start${NC}"
H
hzcheng 已提交
857
        else
P
plum-lihui 已提交
858
            echo -e "${GREEN_DARK}To start TDengine     ${NC}: ./taosd${NC}"
H
hzcheng 已提交
859 860
        fi

H
Hui Li 已提交
861
        if [ ${openresty_work} = 'true' ]; then
H
Hui Li 已提交
862
            echo -e "${GREEN_DARK}To access TDengine    ${NC}: use ${GREEN_UNDERLINE}taos -h $serverFqdn${NC} in shell OR from ${GREEN_UNDERLINE}http://127.0.0.1:${nginx_port}${NC}"
S
slguan 已提交
863
        else
H
Hui Li 已提交
864
            echo -e "${GREEN_DARK}To access TDengine    ${NC}: use ${GREEN_UNDERLINE}taos -h $serverFqdn${NC} in shell${NC}"
S
slguan 已提交
865
        fi
866

H
hzcheng 已提交
867 868 869
        echo
        echo -e "\033[44;32;1mTDengine is updated successfully!${NC}"
    else
L
lihui 已提交
870
        install_bin
H
hzcheng 已提交
871 872 873 874 875 876 877 878 879 880 881 882
        install_config

        echo
        echo -e "\033[44;32;1mTDengine client is updated successfully!${NC}"
    fi

    rm -rf $(tar -tf taos.tar.gz)
}

function install_TDengine() {
    # Start to install
    if [ ! -e taos.tar.gz ]; then
H
Hui Li 已提交
883 884
      echo "File taos.tar.gz does not exist"
      exit 1
H
hzcheng 已提交
885
    fi
L
lihui 已提交
886
    tar -zxf taos.tar.gz
H
hzcheng 已提交
887

L
lihui 已提交
888
    echo -e "${GREEN}Start to install TDengine...${NC}"
889 890 891

    install_main_path

H
hzcheng 已提交
892 893
    if [ -z $1 ]; then
        install_data
894 895 896
    fi

    install_log
H
hzcheng 已提交
897 898
    install_header
    install_lib
L
lihui 已提交
899 900 901
    if [ "$pagMode" != "lite" ]; then
      install_connector
    fi
H
hzcheng 已提交
902 903 904 905 906 907
    install_examples

    if [ -z $1 ]; then # install service and client
        # For installing new
        install_bin
        install_service
S
slguan 已提交
908

H
Hui Li 已提交
909 910
        openresty_work=false
        if [ "$verMode" == "cluster" ]; then
S
slguan 已提交
911 912 913 914 915 916 917 918 919 920
            # Check if nginx is installed successfully
            if type curl &> /dev/null; then
                if curl -sSf http://127.0.0.1:${nginx_port} &> /dev/null; then
                    echo -e "\033[44;32;1mNginx for TDengine is installed successfully!${NC}"
                    openresty_work=true
                else
                    echo -e "\033[44;31;5mNginx for TDengine does not work! Please try again!\033[0m"
                fi
            fi
        fi
921 922

        install_config
H
hzcheng 已提交
923 924

        # Ask if to start the service
H
Hui Li 已提交
925 926
        #echo
        #echo -e "\033[44;32;1mTDengine is installed successfully!${NC}"
H
hzcheng 已提交
927 928
        echo
        echo -e "${GREEN_DARK}To configure TDengine ${NC}: edit /etc/taos/taos.cfg"
P
plum-lihui 已提交
929
        if ((${service_mod}==0)); then
H
Hui Li 已提交
930
          echo -e "${GREEN_DARK}To start TDengine     ${NC}: ${csudo} systemctl start taosd${NC}"
P
plum-lihui 已提交
931
        elif ((${service_mod}==1)); then
H
Hui Li 已提交
932
          echo -e "${GREEN_DARK}To start TDengine     ${NC}: ${csudo} service taosd start${NC}"
H
hzcheng 已提交
933
        else
H
Hui Li 已提交
934
          echo -e "${GREEN_DARK}To start TDengine     ${NC}: taosd${NC}"
935
        fi
H
Hui Li 已提交
936

H
Hui Li 已提交
937 938 939 940 941
        #if [ ${openresty_work} = 'true' ]; then
        #     echo -e "${GREEN_DARK}To access TDengine    ${NC}: use ${GREEN_UNDERLINE}taos${NC} in shell OR from ${GREEN_UNDERLINE}http://127.0.0.1:${nginx_port}${NC}"
        #else
        #     echo -e "${GREEN_DARK}To access TDengine    ${NC}: use ${GREEN_UNDERLINE}taos${NC} in shell${NC}"
        #fi
942

H
Hui Li 已提交
943
        if [ ! -z "$firstEp" ]; then
944 945 946 947 948 949 950 951 952 953 954 955 956 957
            tmpFqdn=${firstEp%%:*}
            substr=":"
            if [[ $firstEp =~ $substr ]];then
                tmpPort=${firstEp#*:}
            else
                tmpPort=""
            fi
            if [[ "$tmpPort" != "" ]];then
                echo -e "${GREEN_DARK}To access TDengine    ${NC}: taos -h $tmpFqdn -P $tmpPort${GREEN_DARK} to login into cluster, then${NC}"
            else
                echo -e "${GREEN_DARK}To access TDengine    ${NC}: taos -h $tmpFqdn${GREEN_DARK} to login into cluster, then${NC}"
            fi
            echo -e "${GREEN_DARK}execute ${NC}: create dnode 'newDnodeFQDN:port'; ${GREEN_DARK}to add this new node${NC}"
            echo
H
Hui Li 已提交
958
        elif [ ! -z "$serverFqdn" ]; then
959 960
            echo -e "${GREEN_DARK}To access TDengine    ${NC}: taos -h $serverFqdn${GREEN_DARK} to login into TDengine server${NC}"
            echo
S
slguan 已提交
961
        fi
962

H
hzcheng 已提交
963
        echo -e "\033[44;32;1mTDengine is installed successfully!${NC}"
964
        echo
H
hzcheng 已提交
965 966 967 968 969 970
    else # Only install client
        install_bin
        install_config
        echo
        echo -e "\033[44;32;1mTDengine client is installed successfully!${NC}"
    fi
971
    touch ~/.taos_history
H
hzcheng 已提交
972 973 974 975 976
    rm -rf $(tar -tf taos.tar.gz)
}


## ==============================Main program starts from here============================
H
[NONE]  
Hui Li 已提交
977
serverFqdn=$(hostname)
H
Hui Li 已提交
978
if [ "$verType" == "server" ]; then
H
hzcheng 已提交
979 980
    # Install server and client
    if [ -x ${bin_dir}/taosd ]; then
S
slguan 已提交
981
        update_flag=1
H
hzcheng 已提交
982 983 984 985
        update_TDengine
    else
        install_TDengine
    fi
H
Hui Li 已提交
986 987
elif [ "$verType" == "client" ]; then
    interactiveFqdn=no
H
hzcheng 已提交
988 989
    # Only install client
    if [ -x ${bin_dir}/taos ]; then
S
slguan 已提交
990
        update_flag=1
H
hzcheng 已提交
991 992 993 994
        update_TDengine client
    else
        install_TDengine client
    fi
995 996
else
    echo  "please input correct verType"
H
hzcheng 已提交
997
fi